#
# vim:set syntax=python:
#import os

import java 
import sys
import time
import re
from time import gmtime, strftime

lineSeparator = java.lang.System.getProperty('line.separator') 

#-----------------------------------------------------
#
#  Set Iteration time
#
#-----------------------------------------------------
def iterationTime(cfg, object, itertime):

        #print "++++++++++++++++++++++++"
        #print strftime("%H:%M:%S", gmtime())
        #print object
	if not object.has_key('iterationTime'):
                #print object
                #print "Setting iteration to %s for" %itertime
		object[ 'iterationTime' ] = itertime
		#object[ 'iterationTime' ] = cfg.longIterationTime
	
	# If lastStatus exists, then check if its time to try again

	if object.has_key('lastStatus'):
                #print time.time() 
                #print object[ 'lastStatus' ][ 'time' ] 
                #print object[ 'iterationTime' ]
		if (object[ 'lastStatus' ][ 'time' ] + object[ 'iterationTime' ]) > time.time():
			dateIteration( cfg, object )
			return None
			
	dateIteration( cfg, object )
	return 1
	


def dateIteration(cfg, object):

	currtime = time.time()

 	#print "--Date Iteration--" 
 	#print "   next: %s" % (cfg.nextIterationTime - currtime) 
 	#print "Object is:" 
 	#print object 

	if object.has_key('lastStatus'):
                # print "Has Last Status" 
		if ( object[ 'lastStatus' ][ 'time' ] + object[ 'iterationTime' ] ) < cfg.nextIterationTime:
			cfg.nextIterationTime = currtime + object[ 'iterationTime' ] 
			#cfg.nextIterationTime = object[ 'lastStatus' ][ 'time' ] + object[ 'iterationTime' ] 
                        # print "nowNext: %s" % (currtime - cfg.nextIterationTime) 
	
	
	else: 
                # print "Doesn't have Last Status" 
		if ( time.time() + object[ 'iterationTime' ] ) < cfg.nextIterationTime:
			cfg.nextIterationTime = currtime + object[ 'iterationTime' ] 
                        # print "nowNext: %s" % (currtime - cfg.nextIterationTime) 
                        # print "------------------" 
		
	return currtime

#==================================================================
#
#  SLEEP UNTIL READY FOR NEXT ITERATION
#
#==================================================================
def iterate( cfg ):

	#print "Looping, Iteration count is: %s" % cfg.iterations
	#print "Previous Iteration time was: %s" % (time.time() - cfg.prevIterationTime)

        currtime = time.time()
	cfg.prevIterationTime = cfg.nextIterationTime

	if cfg.nextIterationTime > currtime:
		sleepTime = cfg.nextIterationTime - currtime + 5
		print "Nothing to do for %s seconds . . . Sleeping" % sleepTime
		time.sleep( sleepTime )

	cfg.nextIterationTime = time.time() + 999999
	cfg.iterations = cfg.iterations + 1
