#
# vim:set syntax=python:
#import os

import java 
import sys
import time
import re
from IAG.control import *
from time import gmtime, strftime

lineSeparator = java.lang.System.getProperty('line.separator') 

#    ~                                                                                    
#   ~ ~    ~~~~~   ~~~~~   ~          ~     ~~~~     ~~     ~~~~~     ~     ~~~~   ~    ~ 
#  ~   ~   ~    ~  ~    ~  ~          ~    ~    ~   ~  ~      ~       ~    ~    ~  ~~   ~ 
# ~     ~  ~    ~  ~    ~  ~          ~    ~       ~    ~     ~       ~    ~    ~  ~ ~  ~ 
# ~~~~~~~  ~~~~~   ~~~~~   ~          ~    ~       ~~~~~~     ~       ~    ~    ~  ~  ~ ~ 
# ~     ~  ~       ~       ~          ~    ~    ~  ~    ~     ~       ~    ~    ~  ~   ~~ 
# ~     ~  ~       ~       ~~~~~~     ~     ~~~~   ~    ~     ~       ~     ~~~~   ~    ~ 
#                                                                                         
def list(cfg, server):
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

	# wsadmin>print AdminApp.list('WebSphere:name=SysOrmOrm2M1,process=SysOrmOrm2M1,platform=proxy,node=uaswas10N3,j2eeType=J2EEServer,version=7.0.0.7,type=Server,mbeanIdentifier=cells/SysOrmCell/nodes/uaswas10N3/servers/SysOrmOrm2M1/server.xml#Server_1259797884838,cell=SysOrmCell,spec=1.0,processType=ManagedProcess') 
	# ClaimsAdapter 
	# ConsumerEAR 
	# DocManEAR 
	# ORMEAR 
	# TenderingEAR 
	# TransAdminEAR 
	# WRMEAR 
	# wsadmin> 
	list = []
	for application in AdminApp.list( "WebSphere:cell=%s,node=%s,server=%s" % (server[ 'cellName' ], server[ 'nodeName' ], server[ 'name' ]) ).splitlines():
		list.append({'name': application })

	server[ 'applications' ] = list
	server[ 'applicationsCached' ] = time.time()  
	return 
	


# def testApp( AppNm, AppSvrNm, NodeNm, outputType='Introscope' ): 

#----------------------------------------------------------------------------------------------
#
# Test is the application is started
#
#   wsadmin>print AdminControl.completeObjectName('type=Application,name=DocManEAR,Server=SysOrmDocMan2M2,*')
#   WebSphere:name=DocManEAR,process=SysOrmDocMan2M2,platform=dynamicproxy,node=uaswas11N3,J2EEName=DocManEAR,Server=SysOrmDocMan2M2,version=7.0.0.7,type=Application,mbeanIdentifier=cells/SysOrmCell/applications/DocManEAR.ear/deployments/DocManEAR/deployment.xml#ApplicationDeployment_1259883649141,cell=SysOrmCell,spec=1.0
#   wsadmin>print AdminControl.completeObjectName('type=Application,name=TransportVerification ,*')
#   
#----------------------------------------------------------------------------------------------
def testIfStarted(cfg, application, server):
	try:
		AdminControl = cfg.AdminControl
	except: 
		print "Can Load the wsadmin Modules"

        #print strftime("%Y-%m-%d %H:%M:%S", gmtime())
        #print strftime("%H:%M:%S", gmtime())
	# check if it is time to check yet
	if iterationTime( cfg, application, cfg.appIterationTime + 60 ) == None:
		return None

        #print "Check APP"
# 	print "AdminControl.completeObjectName(" + 'type=Application,name=' + application[ 'name' ] + \ 
# 	                                           ',Server='               + server[ 'name' ]      + \ 
# 	                                           ',Node='                 + server[ 'nodeName' ]    + ',*' + ")"  
# 		                                         ',Node='                 + server[ 'nodeName' ]    + ',*') 

	try:
		result = AdminControl.completeObjectName('type=Application,name=' + application[ 'name' ] + 
		                                         ',Server='               + server[ 'name' ]      + 
		                                         ',*')
		if result == '':
			application[ 'lastStatus' ] = { 'bool': '0', 'msg': 'Stopped', 'time': time.time(), 'stime':strftime("%H:%M:%S", gmtime()) }
			return '1'
	except:
		application[ 'lastStatus' ] = { 'bool': '0', 'msg': 'Stopped', 'time': time.time(), 'stime':strftime("%H:%M:%S", gmtime()) }
		return '1'

	application[ 'lastStatus' ] = { 'bool': '1', 'msg': 'Started', 'time': time.time(), 'stime':strftime("%H:%M:%S", gmtime()) }

	return '1'
